<?php

namespace App\Controllers\Admin\Cloudflare\API;

use App\Libraries\Log\Log;
use App\Models\Cloudflare\API\ZoneModel;
use CodeIgniter\HTTP\RequestInterface;
use CodeIgniter\HTTP\ResponseInterface;
use Psr\Log\LoggerInterface;
use App\Libraries\Cloudflare\API\Zone;

class ZoneController extends APIController
{
    private $_account_uids = null;
    public function initController(RequestInterface $request, ResponseInterface $response, LoggerInterface $logger)
    {
        parent::initController($request, $response, $logger);
        $this->_className .= '/Zone';
        $this->_model = new ZoneModel();
        $this->_defines = [
            'insert' => [
                'fields' => ['account_uid', 'type', 'content', 'domains', 'proxied'],
                'fieldFilters'  => [],
                'fieldRules' => [
                    'account_uid'    => 'required|min_length[10]|max_length[200]',
                    'type'           => 'required|in_list[A,CNAME,MX,SPF,TXT,NS,INFO]',
                    'content'        => 'required|trim|min_length[4]',
                    'domains'        => 'required|trim|min_length[4]',
                    'proxied'        => 'required|string',
                ]
            ],
            'index' => [
                'fields' => ['account_uid', 'domain', 'name_servers', 'original_name_servers', 'plan', 'development_mode', 'ipv6', 'security_level', 'status', 'updated_at', 'created_at'],
                'fieldFilters' => ['account_uid', 'development_mode', 'ipv6', 'security_level', 'status'],
                'batchjobFilters' => ['development_mode', 'ipv6', 'security_level'],
            ],
            'excel' => [
                'fields' => ['account_uid', 'domain', 'name_servers', 'original_name_servers', 'plan', 'development_mode', 'ipv6', 'security_level', 'status', 'updated_at', 'created_at'],
                'fieldFilters' => ['account_uid', 'development_mode', 'ipv6', 'security_level', 'status'],
            ],
        ];
        helper($this->_className);
        $this->_viewPath = strtolower($this->_className);
        $this->_viewDatas['title'] = lang($this->_className . '.title');
        $this->_viewDatas['className'] = $this->_className;
    }

    //Field별 Form Option용
    protected function getFieldFormOption(string $field): array
    {
        switch ($field) {
            case 'account_uid':
                if (is_null($this->_account_uids)) {
                    //모든 필요한 FormOption등 조기화작업 필요
                    $this->_account_uids = [DEFAULT_EMPTY => lang($this->_className . '.label.' . $field) . ' 선택'];
                    foreach ($this->getAccountModel()->where('status', 'use')->orderBy('title', 'asc')->findAll() as $account) {
                        $this->_account_uids[$account['uid']] = $account['title'];
                    }
                }
                return $this->_account_uids;
                break;
            default:
                return parent::getFieldFormOption($field);
                break;
        }
    }

    //Insert관련
    protected function insert_validate()
    {
        parent::insert_validate();
        //Content 검증 Type이 A 인경우 IP형식 검사
        if ($this->_viewDatas['fieldDatas']['type'] === 'A') {
            if (!isIPAddress_CommonHelper($this->_viewDatas['fieldDatas']['content'], $this->_viewDatas['fieldDatas']['type'])) {
                throw new \Exception("{$this->_viewDatas['title']}의 {$this->_viewDatas['fieldDatas']['type']}, {$this->_viewDatas['fieldDatas']['content']} 형식 오류[사설IP 않됨]");
            }
        }
        //Domain검증
        $this->_viewDatas['fieldDatas']['domains'] = explode("\n", $this->_viewDatas['fieldDatas']['domains']);
        $cnt = 1;
        foreach ($this->_viewDatas['fieldDatas']['domains'] as $domain) {
            if (!isDomain_CommonHelper($domain)) {
                throw new \Exception("{$this->_viewDatas['title']}의 {$cnt}번째 {$domain} 형식 오류");
            }
            if (!$this->_model->isUniqueDomain($this->_viewDatas['fieldDatas'][$this->_model::PARENT_FIELD], $domain)) {
                throw new \Exception("{$this->_viewDatas['title']}의 {$cnt}번째 {$domain}은 이미 등록된 도메인입니다.");
            }
            $cnt++;
        }
        //Host검증
        $this->_viewDatas['fieldDatas']['hosts'] = $this->request->getVar('hosts');
        if (!is_array($this->_viewDatas['fieldDatas']['hosts']) || count($this->_viewDatas['fieldDatas']['hosts']) === 0) {
            throw new \Exception($this->_viewDatas['title'] . '가 호스트명이 선택되지 않았습니다.');
        }
        $cnt = 1;
        foreach ($this->_viewDatas['fieldDatas']['hosts'] as $host) {
            if (!isHost_CommonHelper($host)) {
                throw new \Exception("{$this->_viewDatas['title']}의 {$cnt}번째 {$host} 호스트명 형식 오류");
            }
            $cnt++;
        }
    }
    protected function insert_process()
    {
        foreach ($this->_viewDatas['fieldDatas']['domains'] as $domain) {
            $account = $this->getAccountModel()->gentEntity($this->_viewDatas['fieldDatas'][$this->_model::PARENT_FIELD]);
            $zone = $this->insert_Zone($account, $domain);
            foreach ($this->_viewDatas['fieldDatas']['hosts'] as $host) {
                $this->insert_Host(
                    $zone,
                    $host,
                    $this->_viewDatas['fieldDatas']['type'],
                    $this->_viewDatas['fieldDatas']['content'],
                    $this->_viewDatas['fieldDatas']['proxied']
                );
            }
        }
    }
    //Update관련
    protected function update_process($entity)
    {
        $api = new Zone($this->getAccountModel()->gentEntity($entity->getParentFieldData()));
        $entity = $api->update($entity, $this->_viewDatas['fieldDatas']);
        return parent::update_process($entity);
    }
    //Toggle관련
    protected function toggle_process($entity)
    {
        $api = new Zone($this->getAccountModel()->gentEntity($entity->getParentFieldData()));
        $entity = $api->update($entity, $this->_viewDatas['fieldDatas']);
        return parent::toggle_process($entity);
    }
    //Batchjob관련
    protected function batchjob_process($entity)
    {
        $api = new Zone($this->getAccountModel()->gentEntity($entity->getParentFieldData()));
        $entity = $api->update($entity, $this->_viewDatas['fieldDatas']);
        return parent::batchjob_process($entity);
    }
    //Delete 관련
    protected function delete_process($entity)
    {
        $api = new Zone($this->getAccountModel()->gentEntity($entity->getParentFieldData()));
        $api->delete($entity);
        return parent::delete_process($entity);
    }
    //Sync관련
    protected function sync_process($entity)
    {
        $api = new Zone($this->getAccountModel()->gentEntity($entity->getParentFieldData()));
        $entity = $api->sync($entity);
        return parent::sync_process($entity);
    }
    //Reload관련
    final public function reload($uid)
    {
        try {
            $entity = $this->_model->getEntity($uid);
            $recordApi = new \App\Libraries\Cloudflare\API\Record($entity);
            $recordApi->reload();
            //Firewall Reload
            // $firewallApi = new \App\Libraries\Cloudflare\API\Firewall($entity);
            // $firewallApi->reload();
            return alert_CommonHelper("{$this->_viewDatas['title']} " . __FUNCTION__ . " 완료하였습니다.", session()->get(RETURN_URL));
        } catch (\Exception $e) {
            return alert_CommonHelper($e->getMessage(), 'back');
        }
    }
    //일괄삭제관련
    final public function batchjob_delete()
    {
        $message = "";
        try {
            $uids = $this->request->getVar('batchjob_uids');
            if (!is_array($uids) || count($uids) === 0) {
                throw new \Exception($this->_viewDatas['title'] . '가 uid가 선택되지 않았습니다.');
            }
            foreach ($uids as $uid) {
                $this->delete_process($this->_model->getEntity($uid));
            }
            $message = "총:" . count($uids) . "개의 삭제 완료하였습니다.";
            Log::save("{$this->_viewDatas['title']} {$message}");
            return alert_CommonHelper($message, session()->get(RETURN_URL));
        } catch (\Exception $e) {
            $message = "삭제 실패하였습니다.";
            Log::add("warning", $message . "\n" . $e->getMessage());
            Log::save("{$this->_viewDatas['title']} {$message}", false);
            return alert_CommonHelper($message . "\n" . $e->getMessage(), 'back');
        }
    }
}
